/*
 * ipblocks -- string parsing conversion utility for parsing subnet/bitmask notation
 *
 * skape
 * 06/01/2002
 */

#ifndef _IPBLOCKS_H
#define _IPBLOCKS_H

typedef struct _ipblock_table {

	unsigned long  *ips;

	unsigned long  entries;

} IPBLOCK_TABLE;

typedef struct _ipblock {

	IPBLOCK_TABLE  *table;

	unsigned long  tableElements;
	unsigned long  subnet;
	unsigned long  netmask;
	unsigned char  bitmask;

	unsigned long  ipCount;

	/* Used with enumeration */

	unsigned long  currentIpContext;
	unsigned long  currentIpCount;

} IPBLOCK;

#define IPBLOCK_TABLEIZE 	0x01

short ipblocksParseString(const char *blockString, unsigned long *subnet, unsigned long *netmask, unsigned char *bitmask);
unsigned long ipblocksGetIpCountString(const char *blockString);

IPBLOCK *ipblocksCreateIpBlock(const char *blockString, unsigned long entriesPerSlot, unsigned short flags);
unsigned long ipblocksGetIpCount(IPBLOCK *ipblock);
int ipblocksEnumerate(IPBLOCK *ipblock, unsigned long *array, unsigned long elements);
void ipblocksReset(IPBLOCK *ipblock);
void ipblocksDestroyIpBlock(IPBLOCK *ipblock);

#endif
